#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


#define BGM_FILE	"music.dat"
#define MAX_BGM		31

int bgmtable[MAX_BGM][3]={
	{0x0000002c,0x004c7e68,0x0119aa78},
	{0x1b200d70,0x00256148,0x008f8e90},
	{0x02613798,0x00168404,0x00e94724},
	{0x1beb76bc,0x00226a20,0x008f8e08},
	{0x1d5f3714,0x00159f9c,0x00915a44},
	{0x0384ce38,0x00259138,0x00f36bc4},
	{0x04b739d4,0x00259118,0x00f36b7c},
	{0x1ed168e8,0x00281c18,0x00887a00},
	{0x2141fa3c,0x001434c4,0x00791fe0},
	{0x05eb0d38,0x001bc988,0x00f23f70},
	{0x1e1fa8bc,0x000b73bc,0x0096bb94},
	{0x1caae6e8,0x000bc44c,0x0099d2f4},
	{0x071d20c4,0x004e4d40,0x01b67ebc},
	{0x2075a210,0x001bd3e8,0x00ac4398},
	{0x0951a418,0x001521b8,0x013cf1c8},
	{0x0ab0f2a8,0x00d0af0c,0x004033fc},
	{0x1f900114,0x001a5228,0x00c1cc84},
	{0x017de0ec,0x00000000,0x00e35680},
	{0x0be5e47c,0x0023aebc,0x00d252f0},
	{0x0cf720f4,0x001ae914,0x00d9cbac},
	{0x0df6c9b0,0x0038d854,0x00edff88},
	{0x0f479f9c,0x0026b8e8,0x00fc1b7c},
	{0x10842c60,0x00239954,0x00dcfd44},
	{0x11af6cec,0x0011857c,0x00f46e48},
	{0x12c60f20,0x001a2ff0,0x00d5d91c},
	{0x13d7a0c4,0x001e5554,0x00ecdcd4},
	{0x150df180,0x0014adec,0x00e6b694},
	{0x162b1030,0x001886fc,0x01066f54},
	{0x1778f474,0x0010a52c,0x00ec51f4},
	{0x18899288,0x003359dc,0x01275008},
	{0x1a0e723c,0x001d2610,0x00d525c4}
};

char bgmfile[MAX_BGM][50]={
	"01 zV.wav",
	"02 퍿.wav",
	"03 n̐F͉F.wav",
	"04 b_.wav",
	"05 Z.wav",
	"06 t.wav",
	"07 x鐅.wav",
	"08 ȋ.wav",
	"09 cs.wav",
	"10 }̗VY.wav",
	"11 Ր.wav",
	"12 _OV.wav",
	"13 Cɍg@` Legendary Fish.wav",
	"14 VߖD.wav",
	"15 LVρ@` Wonderful Heaven.wav",
	"16 cSn̗LV.wav",
	"17 FR.wav",
	"18 zV.wav",
	"19 dk.wav",
	"20 ̊@` Casket of Star.wav",
	"21 tOiCg.wav",
	"22 uNVeB̐l`t.wav",
	"23 LLˉ ` Till WhenH.wav",
	"24 NgK[@` .wav",
	"25 Hɍ炩An̍@` Border of Life.wav",
	"26 Sׂ̈̃Zvebg.wav",
	"27 邪~Ă.wav",
	"28 ӌ.wav",
	"29 C̓@` Invisible Full Moon.wav",
	"30 _.wav",
	"31 ފ݋Aq@` Riverside View.wav"
};

void makeheader(char *header,int datasize){
	int i;
	short s;
	memcpy(header,"RIFF",4);
	i = datasize + 36;
	memcpy(header+4,&i,4);
	memcpy(header+8,"WAVEfmt ",8);
	i = 16;
	memcpy(header+16,&i,4);
	s = 1;
	memcpy(header+20,&s,2);
	s = 2;
	memcpy(header+22,&s,2);
	i = 44100;
	memcpy(header+24,&i,4);
	i = 176400;
	memcpy(header+28,&i,4);
	s = 4;
	memcpy(header+32,&s,2);
	s = 16;
	memcpy(header+34,&s,2);
	memcpy(header+36,"data",4);
	i = datasize;
	memcpy(header+40,&i,4);

}

int main(int argc,char *argv[]){
	FILE *datf,*bgmf;
	int i,j,l,k;
	int rep=2;
	int length;
	int fade=0;
	int fadep=0;
	int ts=0;
	int te=MAX_BGM;
	char header[44];
	short buf[44100*2];
	int s,e;
	double d;


	//bgmtable(JnAJԂn_܂ł̒AI_܂ł̒)Ȃ̂
	//ꂼʒuɊZ
	for(i=0;i<MAX_BGM;i++){
		bgmtable[i][1]+=bgmtable[i][0];
		bgmtable[i][2]+=bgmtable[i][1];//ύXς
	}

	//argc̃`FbN
	for(i=1;i<argc;i++){
		switch(argv[i][0]){
		case 'f' :
			argv[i]++; fade=atoi(argv[i]); break;
		case 'F' :
			argv[i]++; fade=-atoi(argv[i]); break;
		case 'P' :
		case 'p' :
			argv[i]++; fadep=atoi(argv[i]); break;
		case 'T' :
		case 't' :
			argv[i]++; ts=te=atoi(argv[i]); break;
		default:
			rep=atoi(argv[i]);
		}
	}

	if(rep<1 || rep>10){
		printf("repeat must be 1-10\n");
		return 0;
	}
	if(fade<-30 || fade>30){
		printf("fade must be 0-30\n");
		return 0;
	}
	if(fadep<0 || fadep>3){
		printf("fade pattern must be 0-3\n");
		return 0;
	}
	if(ts<0 || te>MAX_BGM){
		printf("track number must be 1-%d\n", MAX_BGM);
		return 0;
	}


	printf("track=%d-%d , repeat=%d , fade=%d , fade pattern=%d\n",ts+1,te,rep,fade,fadep);
	if(ts) ts--;

	datf=fopen(BGM_FILE,"rb");
	if(datf==NULL){
		printf("%s not found.", BGM_FILE);
		return 0;
	}

	//Jn
	for(i=ts;i<te;i++){

		printf("Create %s ...\n",bgmfile[i]);
		bgmf=fopen(bgmfile[i],"wb");
		length=(bgmtable[i][2]-bgmtable[i][0])+(bgmtable[i][2]-bgmtable[i][1])*(rep-1);
		if(fade<0) length+=(-fade)*44100*4;
		makeheader(header,length);
		fwrite(header,1,44,bgmf);

		//[v
		for(k=0;k<rep;k++){
			//[
			s=bgmtable[i][1];
			if(k==0) s=bgmtable[i][0];

			//I[
			e=bgmtable[i][2];
			if(k==rep-1 && fade>0) e=bgmtable[i][2]-fade*44100*4;

			for(j=s;j<e;j+=44100*4){
				if(j+44100*4>e) l=e-j;
				else l=44100*4;

				fseek(datf,j,SEEK_SET);
				fread(buf,1,l,datf);
				fwrite(buf,1,l,bgmf);
			}
		}

		//tF[hAEg
		if(fade>0){
			//[vI[
			s=bgmtable[i][2]-fade*44100*4;
			e=bgmtable[i][2];
		}
		else if(fade<0){
			//[v[
			s=bgmtable[i][1];
			e=s-fade*44100*4;
		}
		else{
			s=e=0;
		}

		for(j=s;j<e;j+=44100*4){
			if(j+44100*4>e) l=e-j;
			else l=44100*4;

			fseek(datf,j,SEEK_SET);
			fread(buf,1,l,datf);
			for(k=0;k<l/4;k++){
				switch (fadep) {
				case 0 :
					d=(float)((j-s)/4+k)/(abs(fade)*44100);
					d=pow(0.001,d);
					break;
				case 1 :
					d=1-(float)((j-s)/4+k)/(abs(fade)*44100);
					break;
				case 2 :
					d=(float)((j-s)/4+k)/(abs(fade)*44100);
					d=(pow(0.001,d)+(1-d))/2;
					break;
				case 3 :
					d=(cos(3.1415926535*(float)((j-s)/4+k)/(abs(fade)*44100))+1)/2;
					break;
				}

				buf[2*k]=(short)(buf[2*k]*d);
				buf[2*k+1]=(short)(buf[2*k+1]*d);
			}
			fwrite(buf,1,l,bgmf);
		}

		fclose(bgmf);
	}
	fclose(datf);

	return 0;
}
